
#ifndef _VDP_H_
#define _VDP_H_

/* VDP1 memory and registers */
#define VDP1_VRAM   0x25C00000
#define VDP1_FB     0x25C80000
#define TVMR        (*(vuint16 *)0x25D00000)
#define FBCR        (*(vuint16 *)0x25D00002)
#define PTMR        (*(vuint16 *)0x25D00004)
#define EWDR        (*(vuint16 *)0x25D00006)
#define EWLR        (*(vuint16 *)0x25D00008)
#define EWRR        (*(vuint16 *)0x25D0000A)
#define ENDR        (*(vuint16 *)0x25D0000C)
#define EDSR        (*(vuint16 *)0x25D00010)
#define LOPR        (*(vuint16 *)0x25D00012)
#define COPR        (*(vuint16 *)0x25D00014)
#define MODR        (*(vuint16 *)0x25D00016)

/* VDP2 memory and registers */
#define VDP2_VRAM   0x25E00000
#define VDP2_CRAM   0x25F00000
#define TVMD        (*(vuint16 *)0x25F80000)
#define EXTEN       (*(vuint16 *)0x25F80002)
#define TVSTAT      (*(vuint16 *)0x25F80004)
#define VRAMSIZ     (*(vuint16 *)0x25F80006)
#define HCNT        (*(vuint16 *)0x25F80008)
#define VCNT        (*(vuint16 *)0x25F8000A)

#define CYCA0L      (*(vuint16 *)0x25F80010)
#define CYCA0U      (*(vuint16 *)0x25F80012)
#define CYCA1L      (*(vuint16 *)0x25F80014)
#define CYCA1U      (*(vuint16 *)0x25F80016)
#define CYCB0L      (*(vuint16 *)0x25F80018)
#define CYCB0U      (*(vuint16 *)0x25F8001A)
#define CYCB1L      (*(vuint16 *)0x25F8001C)
#define CYCB1U      (*(vuint16 *)0x25F8001E)

#define BGON        (*(vuint16 *)0x25F80020)

/* Global data */
extern vuint16 *vdp1_vram;
extern vuint16 *vdp1_fb;
extern vuint16 *vdp2_vram;
extern vuint16 *vdp2_cram;


/* Function prototypes */
void vdp_init(void);
void wait_hblank(void);
void wait_hblank_in(void);
void wait_hblank_out(void);
void wait_vblank_in(void);
void wait_vblank_out(void);
void wait_vblank(void);

#endif /* _VDP_H_ */

